package map;

import static org.junit.Assert.*;

import java.util.Hashtable;

import org.junit.Test;

public class TestIntegerKey {

	@Test
	public void testCustomizedHashFunction() {
		IntegerKey ik1 = new IntegerKey(1);
		/* 1 % 11 == 1 */
		assertTrue(ik1.hashCode() == 1); 
		
		IntegerKey ik39_1 = new IntegerKey(39);
		/* 39 % 11 == 3 */
		assertTrue(ik39_1.hashCode() == 6);
		
		IntegerKey ik39_2 = new IntegerKey(39);
		assertTrue(ik39_1.equals(ik39_2));
		assertTrue(ik39_1.hashCode() == ik39_2.hashCode());
	}
	
	@Test
	public void testHashTable() {
		Hashtable<IntegerKey, String> table = new Hashtable<>();
		IntegerKey k1 = new IntegerKey(39);
		IntegerKey k2 = new IntegerKey(39);
		assertTrue(k1.equals(k2));
		assertTrue(k1.hashCode() == k2.hashCode());
		table.put(k1, "D");
		assertTrue(table.get(k2).equals("D"));
	}
	

}
